/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.76 Revision 1.161
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.76 2010/07/03 15:49:39 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.161 2015/03/15 01:25:19 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16 16
17MY_PV=${PV/_/-} 17inherit eutils flag-o-matic multilib toolchain-funcs
18if version_is_at_least 4.5.99999999; then 18
19HOMEPAGE="https://www.qt.io/ https://qt-project.org/"
20LICENSE="|| ( LGPL-2.1 GPL-3 )"
21SLOT="4"
22
23case ${PV} in
24 4.?.9999)
25 QT4_BUILD_TYPE="live"
26 EGIT_REPO_URI=(
27 "git://gitorious.org/qt/qt.git"
28 "https://git.gitorious.org/qt/qt.git"
29 )
30 EGIT_BRANCH=${PV%.9999}
31 inherit git-r3
32 ;;
33 *)
34 QT4_BUILD_TYPE="release"
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 35 MY_P=qt-everywhere-opensource-src-${PV/_/-}
36 SRC_URI="http://download.qt.io/archive/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
37 S=${WORKDIR}/${MY_P}
38 ;;
39esac
40
41IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 42[[ ${PN} != qtxmlpatterns ]] && IUSE+=" +exceptions"
21else 43
22 MY_P=qt-x11-opensource-src-${MY_PV} 44DEPEND="virtual/pkgconfig"
45if [[ ${QT4_BUILD_TYPE} == live ]]; then
46 DEPEND+=" dev-lang/perl"
23fi 47fi
24 48
25HOMEPAGE="http://qt.nokia.com/"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND="
32 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999
38 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV}
51 !>x11-libs/qt-script-${PV}-r9999
52 !<x11-libs/qt-sql-${PV}
53 !>x11-libs/qt-sql-${PV}-r9999
54 !<x11-libs/qt-svg-${PV}
55 !>x11-libs/qt-svg-${PV}-r9999
56 !<x11-libs/qt-test-${PV}
57 !>x11-libs/qt-test-${PV}-r9999
58 !<x11-libs/qt-webkit-${PV}
59 !>x11-libs/qt-webkit-${PV}-r9999
60 !<x11-libs/qt-xmlpatterns-${PV}
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999
62"
63
64S=${WORKDIR}/${MY_P}
65
66# @FUNCTION: qt4-build_pkg_setup 49# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 50# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 51# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 52qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 53 # Warn users of possible breakage when downgrading to a previous release.
71
72 # Protect users by not allowing downgrades between releases
73 # Downgrading revisions within the same release should be allowed 54 # Downgrading revisions within the same release is safe.
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 55 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 56 ewarn
76 eerror "Sanity check to keep you from breaking your system:"
77 eerror " Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system"
79 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 57 ewarn "Downgrading Qt is completely unsupported and can break your system!"
81 fi 58 ewarn
82 fi
83
84 if [[ "${PN}" == "qt-webkit" ]]; then
85 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([0-9])'; then
87 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861"
92 echo
93 fi
94 eshopts_pop
95 fi 59 fi
96 60
97 PATH="${S}/bin${PATH:+:}${PATH}" 61 PATH="${S}/bin${PATH:+:}${PATH}"
98 if [[ ${CHOST} != *-darwin* ]]; then 62 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 63 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 # avoid extract failure. 68 # avoid extract failure.
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 69 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 70 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 71 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 72 fi
109
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi
121} 73}
74
75# @ECLASS-VARIABLE: PATCHES
76# @DEFAULT_UNSET
77# @DESCRIPTION:
78# Array variable containing all the patches to be applied. This variable
79# is expected to be defined in the global scope of ebuilds. Make sure to
80# specify the full path. This variable is used in src_prepare phase.
81#
82# Example:
83# @CODE
84# PATCHES=(
85# "${FILESDIR}/mypatch.patch"
86# "${FILESDIR}/patches_folder/"
87# )
88# @CODE
89
90# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Space-separated list of directories that will be extracted
94# from Qt tarball.
122 95
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DEFAULT_UNSET
124# @DESCRIPTION: 98# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 99# Space-separated list of directories that will be configured,
126# code should be compiled. This is a space-separated list 100# compiled, and installed. All paths must be relative to ${S}.
127
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt
131# tarball
132 101
133# @FUNCTION: qt4-build_src_unpack 102# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 103# @DESCRIPTION:
135# Unpacks the sources 104# Unpacks the sources.
136qt4-build_src_unpack() { 105qt4-build_src_unpack() {
137 setqtenv 106 setqtenv
138 local target targets= 107
108 if [[ $(gcc-major-version) -lt 4 ]] || [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ]]; then
109 ewarn
110 ewarn "Using a GCC version lower than 4.4 is not supported."
111 ewarn
112 fi
113
114 if [[ ${PN} == qtwebkit ]]; then
115 eshopts_push -s extglob
116 if is-flagq '-g?(gdb)?([1-9])'; then
117 ewarn
118 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
119 ewarn "You may experience really long compilation times and/or increased memory usage."
120 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
121 ewarn "For more info check out https://bugs.gentoo.org/307861"
122 ewarn
123 fi
124 eshopts_pop
125 fi
126
127 case ${QT4_BUILD_TYPE} in
128 live)
129 git-r3_src_unpack
130 ;;
131 release)
132 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 133 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 134 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 135 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
136 do
142 targets+=" ${MY_P}/${target}" 137 targets+="${MY_P}/${target} "
143 done 138 done
144 139
140 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 141 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 142 eend $? || die "failed to unpack"
143 ;;
144 esac
147} 145}
148
149# @ECLASS-VARIABLE: PATCHES
150# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure
152# to specify the full path. This variable is necessary for src_prepare phase.
153# example:
154# PATCHES="${FILESDIR}"/mypatch.patch
155# ${FILESDIR}"/mypatch2.patch"
156#
157 146
158# @FUNCTION: qt4-build_src_prepare 147# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 148# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 149# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 150# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
162qt4-build_src_prepare() { 151qt4-build_src_prepare() {
163 setqtenv 152 setqtenv
164 cd "${S}"
165 153
166 # fix qt 4.7 regression that skips -fvisibility=hidden 154 if [[ ${QT4_BUILD_TYPE} == live ]]; then
167 if version_is_at_least "4.7.0_beta1"; then 155 QTDIR="." ./bin/syncqt || die "syncqt failed"
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
169 -i config.tests/unix/fvisibility.test ||
170 die "visibility fixing sed failed"
171 fi 156 fi
157
158 # avoid X11 dependency in non-gui packages
159 local nolibx11_pkgs="qtbearer qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
160 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
172 161
173 if use aqua; then 162 if use aqua; then
174 # provide a proper macx-g++-64 163 # provide a proper macx-g++-64
175 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 164 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
176 165
177 sed -e '/^CONFIG/s:app_bundle::' \ 166 sed -e '/^CONFIG/s:app_bundle::' \
178 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 167 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
179 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 168 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
180 fi 169 fi
181 170
182 if [[ ${PN} != qt-core ]]; then 171 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
183 skip_qmake_build_patch 172 skip_qmake_build
184 skip_project_generation_patch 173 skip_project_generation
185 symlink_binaries_to_buildtree 174 symlink_binaries_to_buildtree
186 fi 175 fi
187 176
188 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 177 if use_if_iuse c++0x; then
189 # qmake bus errors with -O2 but -O3 works 178 append-cxxflags -std=c++0x
190 replace-flags -O2 -O3
191 fi
192
193 # Bug 178652
194 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
195 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
196 append-flags -fno-gcse
197 fi
198
199 # Unsupported old gcc versions - hardened needs this :(
200 if [[ $(gcc-major-version) -lt 4 ]] ; then
201 ewarn "Appending -fno-stack-protector to CXXFLAGS"
202 append-cxxflags -fno-stack-protector
203 # Bug 253127
204 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
205 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
206 fi 179 fi
207 180
208 # Bug 261632 181 # Bug 261632
209 if use ppc64; then 182 if use ppc64; then
210 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
211 append-flags -mminimal-toc 183 append-flags -mminimal-toc
212 fi 184 fi
213 185
214 # Bug 282984 && Bug 295530 186 # Bug 373061
215 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 187 # qmake bus errors with -O2 or -O3 but -O1 works
216 -i configure || die "sed qmake compilers failed" 188 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
217 # bug 321335 189 replace-flags -O[23] -O1
218 if version_is_at_least 4.6; then
219 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \
220 xargs -0 \
221 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):g" \
222 -i || die "sed test compilers failed"
223 fi 190 fi
191
192 # Bug 417105
193 # graphite on gcc 4.7 causes miscompilations
194 if [[ $(gcc-version) == "4.7" ]]; then
195 filter-flags -fgraphite-identity
196 fi
197
198 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
199 sed -e "/^SYSTEM_VARIABLES=/i \
200 CC='$(tc-getCC)'\n\
201 CXX='$(tc-getCXX)'\n\
202 CFLAGS='${CFLAGS}'\n\
203 CXXFLAGS='${CXXFLAGS}'\n\
204 LDFLAGS='${LDFLAGS}'\n\
205 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
206 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
207 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
208 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
209 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
211 -i configure \
212 || die "sed SYSTEM_VARIABLES failed"
213
214 # Respect CC, CXX, LINK and *FLAGS in config.tests
215 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
216 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
217 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
218 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
219 || die "sed config.tests failed"
224 220
225 # Bug 172219 221 # Bug 172219
226 sed -e "s:X11R6/::" \ 222 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
227 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
228 223
229 if [[ ${CHOST} == *-darwin* ]]; then 224 if [[ ${CHOST} == *-darwin* ]]; then
230 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 225 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
231 # crippled (by design) :/ 226 # crippled (by design) :/
227 local mac_gpp_conf=
228 if [[ -f mkspecs/common/mac-g++.conf ]]; then
229 # qt < 4.8 has mac-g++.conf
230 mac_gpp_conf="mkspecs/common/mac-g++.conf"
231 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
232 # qt >= 4.8 has g++-macx.conf
233 mac_gpp_conf="mkspecs/common/g++-macx.conf"
234 else
235 die "no known conf file for mac found"
236 fi
237 sed \
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 238 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 239 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 240 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
235 -e "s:-arch\s\w*::g" \ 241 -e "s:-arch\s\w*::g" \
236 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 242 -i ${mac_gpp_conf} \
243 || die "sed ${mac_gpp_conf} failed"
237 244
238 # Fix configure's -arch settings that appear in qmake/Makefile and also 245 # Fix configure's -arch settings that appear in qmake/Makefile and also
239 # fix arch handling (automagically duplicates our -arch arg and breaks 246 # fix arch handling (automagically duplicates our -arch arg and breaks
240 # pch). Additionally disable Xarch support. 247 # pch). Additionally disable Xarch support.
248 local mac_gcc_confs="${mac_gpp_conf}"
249 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
250 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
251 fi
241 sed \ 252 sed \
242 -e "s:-arch i386::" \ 253 -e "s:-arch i386::" \
243 -e "s:-arch ppc::" \ 254 -e "s:-arch ppc::" \
244 -e "s:-arch x86_64::" \ 255 -e "s:-arch x86_64::" \
245 -e "s:-arch ppc64::" \ 256 -e "s:-arch ppc64::" \
246 -e "s:-arch \$i::" \ 257 -e "s:-arch \$i::" \
247 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 258 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
248 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 259 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
249 -e "s:-Xarch_x86_64::g" \ 260 -e "s:-Xarch_x86_64::g" \
250 -e "s:-Xarch_ppc64::g" \ 261 -e "s:-Xarch_ppc64::g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 262 -i configure ${mac_gcc_confs} \
263 || die "sed -arch/-Xarch failed"
252 264
253 # On Snow Leopard don't fall back to 10.5 deployment target. 265 # On Snow Leopard don't fall back to 10.5 deployment target.
254 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 266 if [[ ${CHOST} == *-apple-darwin10 ]]; then
255 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 267 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
256 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 268 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
257 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 269 -i configure ${mac_gpp_conf} \
270 || die "sed deployment target failed"
258 fi 271 fi
259 fi 272 fi
260 273
261 # this one is needed for all systems with a separate -liconv, apart from 274 # this one is needed for all systems with a separate -liconv, apart from
262 # Darwin, for which the sources already cater for -liconv 275 # Darwin, for which the sources already cater for -liconv
263 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 276 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
264 sed \ 277 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
265 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
266 -i config.tests/unix/iconv/iconv.pro \ 278 -i config.tests/unix/iconv/iconv.pro \
267 || die "sed on iconv.pro failed" 279 || die "sed iconv.pro failed"
268 fi 280 fi
269 281
270 # we need some patches for Solaris 282 # we need some patches for Solaris
271 sed -i \
272 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 283 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
273 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 284 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
274 # use GCC over SunStudio 285 # use GCC over SunStudio
275 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 286 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
276 # don't flirt with non-Prefix stuff, we're quite possessive 287 # do not flirt with non-Prefix stuff, we're quite possessive
277 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 288 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
278 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 289 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
279 # strip predefined CFLAGS from qmake ( bug #312689 )
280 sed -i '/^QMAKE_CFLAGS_\(RELEASE\|DEBUG\)/s:+=.*:+=:' mkspecs/common/g++.conf
281 290
282 base_src_prepare 291 # apply patches
292 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
293 epatch_user
283} 294}
284 295
285# @FUNCTION: qt4-build_src_configure 296# @FUNCTION: qt4-build_src_configure
286# @DESCRIPTION: 297# @DESCRIPTION:
287# Default configure phase 298# Default configure phase
288qt4-build_src_configure() { 299qt4-build_src_configure() {
289 setqtenv 300 setqtenv
290 myconf="$(standard_configure_options) ${myconf}" 301
302 local conf="
303 -prefix ${QTPREFIXDIR}
304 -bindir ${QTBINDIR}
305 -libdir ${QTLIBDIR}
306 -docdir ${QTDOCDIR}
307 -headerdir ${QTHEADERDIR}
308 -plugindir ${QTPLUGINDIR}
309 -importdir ${QTIMPORTDIR}
310 -datadir ${QTDATADIR}
311 -translationdir ${QTTRANSDIR}
312 -sysconfdir ${QTSYSCONFDIR}
313 -examplesdir ${QTEXAMPLESDIR}
314 -demosdir ${QTDEMOSDIR}
315 -opensource -confirm-license
316 -shared -fast -largefile -stl -verbose
317 -nomake examples -nomake demos"
318
319 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
320 # $(tc-arch). Therefore we convert it to supported values.
321 case "$(tc-arch)" in
322 amd64|x64-*) conf+=" -arch x86_64" ;;
323 ppc-macos) conf+=" -arch ppc" ;;
324 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
325 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
326 x86-macos) conf+=" -arch x86" ;;
327 x86|x86-*) conf+=" -arch i386" ;;
328 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
329 arm64|hppa|sh) conf+=" -arch generic" ;;
330 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
331 esac
332
333 conf+=" -platform $(qt_mkspecs_dir)"
334
335 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
336
337 # debug/release
338 if use debug; then
339 conf+=" -debug"
340 else
341 conf+=" -release"
342 fi
343 conf+=" -no-separate-debug-info"
344
345 # exceptions USE flag
346 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
347
348 # disable rpath (bug 380415), except on prefix (bug 417169)
349 use prefix || conf+=" -no-rpath"
350
351 # precompiled headers don't work on hardened, where the flag is masked
352 conf+=" $(qt_use pch)"
353
354 # -reduce-relocations
355 # This flag seems to introduce major breakage to applications,
356 # mostly to be seen as a core dump with the message "QPixmap: Must
357 # construct a QApplication before a QPaintDevice" on Solaris.
358 # -- Daniel Vergien
359 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
291 360
292 # this one is needed for all systems with a separate -liconv, apart from 361 # this one is needed for all systems with a separate -liconv, apart from
293 # Darwin, for which the sources already cater for -liconv 362 # Darwin, for which the sources already cater for -liconv
294 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 363 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
295 myconf+=" -liconv" 364 conf+=" -liconv"
365 fi
296 366
297 if has glib ${IUSE//+} && use glib; then 367 if use_if_iuse glib; then
298 # use -I, -L and -l from configure
299 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 368 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
300 # avoid the -pthread argument 369 # avoid the -pthread argument
301 myconf+=" ${glibflags//-pthread}" 370 conf+=" ${glibflags//-pthread}"
302 unset glibflags 371 unset glibflags
303 fi 372 fi
304 373
305 if use aqua ; then 374 if use aqua; then
306 # On (snow) leopard use the new (frameworked) cocoa code. 375 # On (snow) leopard use the new (frameworked) cocoa code.
307 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 376 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
308 myconf+=" -cocoa -framework" 377 conf+=" -cocoa -framework"
378 # We need the source's headers, not the installed ones.
379 conf+=" -I${S}/include"
380 # Add hint for the framework location.
381 conf+=" -F${QTLIBDIR}"
309 382
310 # We are crazy and build cocoa + qt3support :-) 383 # We are crazy and build cocoa + qt3support :-)
311 if use qt3support; then 384 if use qt3support; then
312 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 385 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
313 -i configure 386 -i configure || die
314 fi 387 fi
315 388 else
316 # We need the source's headers, not the installed ones. 389 conf+=" -no-framework"
317 myconf+=" -I${S}/include"
318
319 # Add hint for the framework location.
320 myconf+=" -F${QTLIBDIR}"
321 fi 390 fi
322 else 391 else
323 # freetype2 include dir is non-standard, thus include it on configure 392 # freetype2 include dir is non-standard, thus pass it to configure
324 # use -I from configure
325 myconf+=" $(pkg-config --cflags freetype2)" 393 conf+=" $(pkg-config --cflags-only-I freetype2)"
326 fi 394 fi
327 395
396 conf+=" ${myconf}"
397 myconf=
398
328 echo ./configure ${myconf} 399 echo ./configure ${conf}
329 ./configure ${myconf} || die "./configure failed" 400 ./configure ${conf} || die "./configure failed"
330 myconf="" 401
402 prepare_directories ${QT4_TARGET_DIRECTORIES}
331} 403}
332 404
333# @FUNCTION: qt4-build_src_compile 405# @FUNCTION: qt4-build_src_compile
406# @DESCRIPTION:
334# @DESCRIPTION: Actual compile phase 407# Actual compile phase
335qt4-build_src_compile() { 408qt4-build_src_compile() {
336 setqtenv 409 setqtenv
337 410
338 build_directories ${QT4_TARGET_DIRECTORIES} 411 build_directories ${QT4_TARGET_DIRECTORIES}
339} 412}
340 413
341# @FUNCTION: qt4-build_src_test 414# @FUNCTION: qt4-build_src_test
342# @DESCRIPTION: 415# @DESCRIPTION:
343# Runs tests only in target directories. 416# Runs tests only in target directories.
344qt4-build_src_test() { 417qt4-build_src_test() {
418 # QtMultimedia does not have any test suite (bug #332299)
419 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
420
345 for dir in ${QT4_TARGET_DIRECTORIES}; do 421 for dir in ${QT4_TARGET_DIRECTORIES}; do
346 emake -j1 check -C ${dir} 422 emake -j1 check -C ${dir}
347 done 423 done
348} 424}
349 425
350# @FUNCTION: fix_includes 426# @FUNCTION: fix_includes
351# @DESCRIPTION: 427# @DESCRIPTION:
352# For MacOSX we need to add some symlinks when frameworks are 428# For MacOS X we need to add some symlinks when frameworks are
353# being used, to avoid complications with some more or less stupid packages. 429# being used, to avoid complications with some more or less stupid packages.
354fix_includes() { 430fix_includes() {
355 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 431 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
432 local frw dest f h rdir
356 # Some packages tend to include <Qt/...> 433 # Some packages tend to include <Qt/...>
357 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 434 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
358 435
359 # Fake normal headers when frameworks are installed... eases life later on 436 # Fake normal headers when frameworks are installed... eases life later
360 local dest f 437 # on, make sure we use relative links though, as some ebuilds assume
438 # these dirs exist in src_install to add additional files
439 f=${QTHEADERDIR}
440 h=${QTLIBDIR}
441 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
442 f=${f#*/}
443 h=${h#*/}
444 done
445 rdir=${h}
446 f="../"
447 while [[ ${h} == */* ]] ; do
448 f="${f}../"
449 h=${h#*/}
450 done
451 rdir="${f}${rdir}"
452
361 for frw in "${D}${QTLIBDIR}"/*.framework; do 453 for frw in "${D}${QTLIBDIR}"/*.framework; do
362 [[ -e "${frw}"/Headers ]] || continue 454 [[ -e "${frw}"/Headers ]] || continue
363 f=$(basename ${frw}) 455 f=$(basename ${frw})
364 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 456 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
365 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 457 dosym "${rdir}"/${f}/Headers "${dest}"
366 458
367 # Link normal headers as well. 459 # Link normal headers as well.
368 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 460 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
369 h=$(basename ${hdr}) 461 h=$(basename ${hdr})
370 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 462 dosym "../${rdir}"/${f}/Headers/${h} \
463 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
371 done 464 done
372 done 465 done
373 fi 466 fi
374} 467}
375 468
376# @FUNCTION: qt4-build_src_install 469# @FUNCTION: qt4-build_src_install
377# @DESCRIPTION: 470# @DESCRIPTION:
378# Perform the actual installation including some library fixes. 471# Perform the actual installation including some library fixes.
379qt4-build_src_install() { 472qt4-build_src_install() {
380 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
381 setqtenv 473 setqtenv
474
382 install_directories ${QT4_TARGET_DIRECTORIES} 475 install_directories ${QT4_TARGET_DIRECTORIES}
383 install_qconfigs 476 install_qconfigs
384 fix_library_files 477 fix_library_files
385 fix_includes 478 fix_includes
479
480 # remove .la files since we are building only shared libraries
481 prune_libtool_files
386} 482}
387 483
388# @FUNCTION: setqtenv 484# @FUNCTION: setqtenv
485# @INTERNAL
389setqtenv() { 486setqtenv() {
390 # Set up installation directories 487 # Set up installation directories
391 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
392 QTPREFIXDIR=${EPREFIX}/usr 488 QTPREFIXDIR=${EPREFIX}/usr
393 QTBINDIR=${EPREFIX}/usr/bin 489 QTBINDIR=${QTPREFIXDIR}/bin
394 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 490 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
395 QMAKE_LIBDIR_QT=${QTLIBDIR}
396 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 491 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
397 QTDATADIR=${EPREFIX}/usr/share/qt4
398 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 492 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
399 QTHEADERDIR=${EPREFIX}/usr/include/qt4 493 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
400 QTPLUGINDIR=${QTLIBDIR}/plugins 494 QTPLUGINDIR=${QTLIBDIR}/plugins
495 QTIMPORTDIR=${QTLIBDIR}/imports
496 QTDATADIR=${QTPREFIXDIR}/share/qt4
497 QTTRANSDIR=${QTDATADIR}/translations
401 QTSYSCONFDIR=${EPREFIX}/etc/qt4 498 QTSYSCONFDIR=${EPREFIX}/etc/qt4
402 QTTRANSDIR=${QTDATADIR}/translations
403 QTEXAMPLESDIR=${QTDATADIR}/examples 499 QTEXAMPLESDIR=${QTDATADIR}/examples
404 QTDEMOSDIR=${QTDATADIR}/demos 500 QTDEMOSDIR=${QTDATADIR}/demos
405 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 501 QMAKE_LIBDIR_QT=${QTLIBDIR}
502
406 PLATFORM=$(qt_mkspecs_dir) 503 PLATFORM=$(qt_mkspecs_dir)
407
408 unset QMAKESPEC 504 unset QMAKESPEC
409}
410 505
411# @FUNCTION: standard_configure_options 506 export XDG_CONFIG_HOME="${T}"
412# @DESCRIPTION: 507}
413# Sets up some standard configure options, like libdir (if necessary), whether
414# debug info is wanted or not.
415standard_configure_options() {
416 local myconf=
417 508
418 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 509# @FUNCTION: prepare_directories
419 510# @USAGE: < directories >
420 # Disable visibility explicitly if gcc version isn't 4 511# @INTERNAL
421 if [[ $(gcc-major-version) -lt 4 ]]; then 512# @DESCRIPTION:
422 myconf+=" -no-reduce-exports" 513# Generates Makefiles for the given list of directories.
423 fi 514prepare_directories() {
424 515 for x in "$@"; do
425 # precompiled headers doesn't work on hardened, where the flag is masked. 516 pushd "${S}"/${x} >/dev/null || die
426 myconf+=" $(qt_use pch)" 517 einfo "Running qmake in: ${x}"
427 518 "${S}"/bin/qmake \
428 if use debug; then 519 "LIBS+=-L${QTLIBDIR}" \
429 myconf+=" -debug" 520 "CONFIG+=nostrip" \
430 else 521 || die "qmake failed"
431 myconf+=" -release" 522 popd >/dev/null || die
432 fi 523 done
433 myconf+=" -no-separate-debug-info"
434
435 use aqua && myconf+=" -no-framework"
436
437 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
438 # $(tc-arch). Therefore we convert it to supported values.
439 case "$(tc-arch)" in
440 amd64|x64-*) myconf+=" -arch x86_64" ;;
441 ppc-macos) myconf+=" -arch ppc" ;;
442 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
443 sparc|sparc-*) myconf+=" -arch sparc" ;;
444 x86-macos) myconf+=" -arch x86" ;;
445 x86|x86-*) myconf+=" -arch i386" ;;
446 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
447 hppa|sh) myconf+=" -arch generic" ;;
448 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
449 esac
450
451 # 4.5: build everything but qt-xmlpatterns w/o exceptions
452 # 4.6: exceptions USE flag
453 local exceptions="-exceptions"
454 case "${PV}" in
455 4.5.*)
456 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
457 ;;
458 *)
459 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
460 ;;
461 esac
462
463 # note about -reduce-relocations:
464 # That flag seems to introduce major breakage to applications,
465 # mostly to be seen as a core dump with the message "QPixmap: Must
466 # construct a QApplication before a QPaintDevice" on Solaris
467 # -- Daniel Vergien
468 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
469
470 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
471 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
472 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
473 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
474 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
475 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
476 ${exceptions}
477 -nomake examples -nomake demos"
478
479 echo "${myconf}"
480} 524}
481 525
482# @FUNCTION: build_directories 526# @FUNCTION: build_directories
483# @USAGE: < directories > 527# @USAGE: < directories >
528# @INTERNAL
484# @DESCRIPTION: 529# @DESCRIPTION:
485# Compiles the code in $QT4_TARGET_DIRECTORIES 530# Compiles the code in the given list of directories.
486build_directories() { 531build_directories() {
487 for x in "$@"; do 532 for x in "$@"; do
488 pushd "${S}"/${x} >/dev/null 533 pushd "${S}"/${x} >/dev/null || die
489 # avoid running over the maximum argument number, bug #299810 534 emake \
490 { 535 AR="$(tc-getAR) cqs" \
491 echo "${S}"/mkspecs/common/*.conf
492 find "${S}" -name '*.pr[io]'
493 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
494 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
495 emake CC="$(tc-getCC)" \ 536 CC="$(tc-getCC)" \
496 CXX="$(tc-getCXX)" \ 537 CXX="$(tc-getCXX)" \
497 LINK="$(tc-getCXX)" || die "emake failed" 538 LINK="$(tc-getCXX)" \
539 RANLIB=":" \
540 STRIP=":"
498 popd >/dev/null 541 popd >/dev/null || die
499 done 542 done
500} 543}
501 544
502# @FUNCTION: install_directories 545# @FUNCTION: install_directories
503# @USAGE: < directories > 546# @USAGE: < directories >
547# @INTERNAL
504# @DESCRIPTION: 548# @DESCRIPTION:
505# run emake install in the given directories, which are separated by spaces 549# Runs emake install in the given directories, which are separated by spaces.
506install_directories() { 550install_directories() {
507 for x in "$@"; do 551 for x in "$@"; do
508 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 552 pushd "${S}"/${x} >/dev/null || die
509 emake INSTALL_ROOT="${D}" install || die "emake install failed" 553 emake INSTALL_ROOT="${D}" install
510 popd >/dev/null || die "Can't popd from ${S}/${x}" 554 popd >/dev/null || die
511 done 555 done
512} 556}
513 557
514# @ECLASS-VARIABLE: QCONFIG_ADD 558# @ECLASS-VARIABLE: QCONFIG_ADD
515# @DESCRIPTION: 559# @DESCRIPTION:
525# @DESCRIPTION: 569# @DESCRIPTION:
526# List variables that should be defined at the top of QtCore/qconfig.h 570# List variables that should be defined at the top of QtCore/qconfig.h
527: ${QCONFIG_DEFINE:=} 571: ${QCONFIG_DEFINE:=}
528 572
529# @FUNCTION: install_qconfigs 573# @FUNCTION: install_qconfigs
574# @INTERNAL
575# @DESCRIPTION:
530# @DESCRIPTION: Install gentoo-specific mkspecs configurations 576# Install gentoo-specific mkspecs configurations.
531install_qconfigs() { 577install_qconfigs() {
532 local x 578 local x
533 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 579 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
534 for x in QCONFIG_ADD QCONFIG_REMOVE; do 580 for x in QCONFIG_ADD QCONFIG_REMOVE; do
535 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 581 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
536 done 582 done
537 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 583 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
538 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 584 doins "${T}"/${PN}-qconfig.pri
539 fi 585 fi
540 586
541 if [[ -n ${QCONFIG_DEFINE} ]]; then 587 if [[ -n ${QCONFIG_DEFINE} ]]; then
542 for x in ${QCONFIG_DEFINE}; do 588 for x in ${QCONFIG_DEFINE}; do
543 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 589 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
544 done 590 done
545 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 591 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
546 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 592 doins "${T}"/gentoo-${PN}-qconfig.h
547 fi 593 fi
548} 594}
549 595
550# @FUNCTION: generate_qconfigs 596# @FUNCTION: generate_qconfigs
551# @DESCRIPTION: Generates gentoo-specific configurations 597# @INTERNAL
598# @DESCRIPTION:
599# Generates gentoo-specific qconfig.{h,pri}.
552generate_qconfigs() { 600generate_qconfigs() {
553 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 601 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
554 local x qconfig_add qconfig_remove qconfig_new 602 local x qconfig_add qconfig_remove qconfig_new
555 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 603 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
556 [[ -f ${x} ]] || continue 604 [[ -f ${x} ]] || continue
557 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 605 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
558 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 606 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
559 done 607 done
560 608
561 # these error checks do not use die because dying in pkg_post{inst,rm} 609 # these error checks do not use die because dying in pkg_post{inst,rm}
562 # just makes things worse. 610 # just makes things worse.
563 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 611 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
564 # start with the qconfig.pri that qt-core installed 612 # start with the qconfig.pri that qtcore installed
565 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 613 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
566 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 614 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
567 eerror "cp qconfig failed." 615 eerror "cp qconfig failed."
568 return 1 616 return 1
569 fi 617 fi
570 618
571 # generate list of QT_CONFIG entries from the existing list 619 # generate list of QT_CONFIG entries from the existing list
572 # including qconfig_add and excluding qconfig_remove 620 # including qconfig_add and excluding qconfig_remove
573 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 621 for x in $(sed -n 's/^QT_CONFIG +=//p' \
574 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 622 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
575 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 623 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
576 done 624 done
577 625
578 # replace the existing QT_CONFIG list with qconfig_new 626 # replace the existing QT_CONFIG list with qconfig_new
579 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 627 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
580 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 628 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
604 fi 652 fi
605 fi 653 fi
606} 654}
607 655
608# @FUNCTION: qt4-build_pkg_postrm 656# @FUNCTION: qt4-build_pkg_postrm
657# @DESCRIPTION:
609# @DESCRIPTION: Generate configurations when the package is completely removed 658# Regenerate configuration when the package is completely removed.
610qt4-build_pkg_postrm() { 659qt4-build_pkg_postrm() {
611 generate_qconfigs 660 generate_qconfigs
612} 661}
613 662
614# @FUNCTION: qt4-build_pkg_postinst 663# @FUNCTION: qt4-build_pkg_postinst
664# @DESCRIPTION:
615# @DESCRIPTION: Generate configuration, plus throws a message about possible 665# Regenerate configuration, plus throw a message about possible
616# breakages and proposed solutions. 666# breakages and proposed solutions.
617qt4-build_pkg_postinst() { 667qt4-build_pkg_postinst() {
618 generate_qconfigs 668 generate_qconfigs
619} 669}
620 670
621# @FUNCTION: skip_qmake_build_patch 671# @FUNCTION: skip_qmake_build
672# @INTERNAL
622# @DESCRIPTION: 673# @DESCRIPTION:
623# Don't need to build qmake, as it's already installed from qt-core 674# Patches configure to skip qmake compilation, as it's already installed by qtcore.
624skip_qmake_build_patch() { 675skip_qmake_build() {
625 # Don't need to build qmake, as it's already installed from qt-core
626 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 676 sed -i -e "s:if true:if false:g" "${S}"/configure || die
627} 677}
628 678
629# @FUNCTION: skip_project_generation_patch 679# @FUNCTION: skip_project_generation
680# @INTERNAL
630# @DESCRIPTION: 681# @DESCRIPTION:
631# Exit the script early by throwing in an exit before all of the .pro files are scanned 682# Exit the script early by throwing in an exit before all of the .pro files are scanned.
632skip_project_generation_patch() { 683skip_project_generation() {
633 # Exit the script early by throwing in an exit before all of the .pro files are scanned
634 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 684 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
635 -i "${S}"/configure || die "Sed failed"
636} 685}
637 686
638# @FUNCTION: symlink_binaries_to_buildtree 687# @FUNCTION: symlink_binaries_to_buildtree
688# @INTERNAL
639# @DESCRIPTION: 689# @DESCRIPTION:
640# Symlink generated binaries to buildtree so they can be used during compilation 690# Symlinks generated binaries to buildtree, so they can be used during compilation time.
641# time
642symlink_binaries_to_buildtree() { 691symlink_binaries_to_buildtree() {
643 for bin in qmake moc uic rcc; do 692 for bin in qmake moc uic rcc; do
644 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 693 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
645 done 694 done
646} 695}
647 696
648# @FUNCTION: fix_library_files 697# @FUNCTION: fix_library_files
698# @INTERNAL
649# @DESCRIPTION: 699# @DESCRIPTION:
650# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 700# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
651# moves the *.pc-files into the pkgconfig directory 701# moves the *.pc files into the pkgconfig directory.
652fix_library_files() { 702fix_library_files() {
703 local libfile
653 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 704 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
654 if [[ -e ${libfile} ]]; then 705 if [[ -e ${libfile} ]]; then
655 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 706 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
656 fi 707 fi
657 done 708 done
658 709
659 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 710 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
660 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 711 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
661 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
662 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 713 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
663 714
664 # Move .pc files into the pkgconfig directory 715 # Move .pc files into the pkgconfig directory
665 dodir ${QTPCDIR#${EPREFIX}} 716 dodir ${QTPCDIR#${EPREFIX}}
666 mv ${libfile} "${D}"/${QTPCDIR}/ \ 717 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
667 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
668 fi 718 fi
669 done 719 done
670 720
671 # Don't install an empty directory 721 # Don't install an empty directory
672 rmdir "${D}"/${QTLIBDIR}/pkgconfig 722 rmdir "${D}"/${QTLIBDIR}/pkgconfig
673} 723}
674 724
675# @FUNCTION: qt_use 725# @FUNCTION: qt_use
676# @USAGE: < flag > [ feature ] [ enableval ] 726# @USAGE: < flag > [ feature ] [ enableval ]
677# @DESCRIPTION: 727# @DESCRIPTION:
678# This will echo "${enableval}-${feature}" if <flag> is enabled, or 728# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
679# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 729# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
680# will be used for that. If [enableval] is not specified, it omits the 730# will be used for that. If [enableval] is not specified, it omits the
681# assignment-part 731# "-${enableval}" part.
682qt_use() { 732qt_use() {
683 local flag=$1 733 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
684 local feature=$1
685 local enableval=
686
687 [[ -n $2 ]] && feature=$2
688 [[ -n $3 ]] && enableval=-$3
689
690 if use ${flag}; then
691 echo "${enableval}-${feature}"
692 else
693 echo "-no-${feature}"
694 fi
695} 734}
696 735
697# @FUNCTION: qt_mkspecs_dir 736# @FUNCTION: qt_mkspecs_dir
698# @RETURN: the specs-directory w/o path 737# @RETURN: the specs-directory w/o path
699# @DESCRIPTION: 738# @DESCRIPTION:
700# Allows us to define which mkspecs dir we want to use. 739# Allows us to define which mkspecs dir we want to use.
701qt_mkspecs_dir() { 740qt_mkspecs_dir() {
702 # Allows us to define which mkspecs dir we want to use.
703 local spec 741 local spec=
704 742
705 case ${CHOST} in 743 case "${CHOST}" in
706 *-freebsd*|*-dragonfly*) 744 *-freebsd*|*-dragonfly*)
707 spec=freebsd ;; 745 spec=freebsd ;;
708 *-openbsd*) 746 *-openbsd*)
709 spec=openbsd ;; 747 spec=openbsd ;;
710 *-netbsd*) 748 *-netbsd*)
721 *-solaris*) 759 *-solaris*)
722 spec=solaris ;; 760 spec=solaris ;;
723 *-linux-*|*-linux) 761 *-linux-*|*-linux)
724 spec=linux ;; 762 spec=linux ;;
725 *) 763 *)
726 die "Unknown CHOST, no platform choosen." 764 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
727 esac 765 esac
728 766
729 CXX=$(tc-getCXX) 767 case "$(tc-getCXX)" in
730 if [[ ${CXX} == *g++* ]]; then 768 *g++*)
731 spec+=-g++ 769 spec+=-g++ ;;
732 elif [[ ${CXX} == *icpc* ]]; then 770 *icpc*)
733 spec+=-icc 771 spec+=-icc ;;
734 else 772 *)
735 die "Unknown compiler ${CXX}." 773 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
736 fi 774 esac
737 if [[ -n ${LIBDIR/lib} ]]; then
738 spec+=-${LIBDIR/lib}
739 fi
740 775
741 # Add -64 for 64bit profiles 776 # Add -64 for 64bit profiles
742 if use x64-freebsd || 777 if use x64-freebsd ||
743 use amd64-linux || 778 use amd64-linux ||
744 use x64-macos || 779 use x64-macos ||
749 fi 784 fi
750 785
751 echo "${spec}" 786 echo "${spec}"
752} 787}
753 788
789# @FUNCTION: qt_nolibx11
790# @INTERNAL
791# @DESCRIPTION:
792# Skip X11 tests for packages that don't need X libraries installed.
793qt_nolibx11() {
794 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
795}
796
754EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 797EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.76  
changed lines
  Added in v.1.161

  ViewVC Help
Powered by ViewVC 1.1.20